Graphics 800,600,32,2
SetBuffer BackBuffer()

; Init
Dim Slide(50)
Dim Hole(50)
Dim Grid(16,50)
Dim Grid2(16,50)
Dim Gets(100)


Global Sliders

Global blobs=LoadAnimImage("system/183/circles.png",32,32,0,100)
Global blobs_dark=LoadAnimImage("system/183/circles_dark.png",32,32,0,100)
Global slider_i=LoadAnimImage("system/183/slideends.png",32,32,0,2)	; Added 2 ends to the sliders.

Global Slider=CreateImage(32,32)
	SetBuffer ImageBuffer(Slider)
	Color 150,150,180
	Rect 0,0,32,32,1
	Color 180,180,220
	Line 0,0,32,0
	Color 80,80,120
	Line 0,31,32,31
	SetBuffer BackBuffer()

GameFont=LoadFont("Arial",64,1)
TitleFont=LoadFont("Arial",32)

.titlescreen
Repeat
Cls
SetFont TitleFont

Color 150,0,0
Text 400,100,"The Super Generic",1,1
Text 400,140,"Quickly Made",1,1
Text 400,180,"Slider Puzzle",1,1
Color 0,150,0
Text 400,220,"Get all the circles into",1,1
Text 400,250,"their associated slots",1,1
Text 400,280,"within the Time Limit",1,1


Color 0,180,255
Text 400,420,"Left click to start",1,1
If MouseHit(1) Then QuickStart=0:Gosub GameLoop:mh1=MouseHit(1):mh1=MouseHit(2)

Color 255,180,0
Text 400,480,"Rightclick for Hard Mode",1,1
If MouseHit(2) Then QuickStart=1:Gosub GameLoop:mh1=MouseHit(1):mh1=MouseHit(2)






Flip
Until KeyDown(1)

End


Function MakeLevel(Level)
SeedRnd MilliSecs()

; Clear everything before we start..
For n=1 To 50
	Slide(n)=0
	Hole(n)=0
	For y=1 To 16
		Grid(y,n)=0
		Grid2(y,n)=0
	Next
	Gets(n)=0
	Gets(n+50)=0
Next


	Sliders=0
	No_Of_Blobs=5
	MoreSliders=17-(No_Of_Blobs*2)	; Made a bit more dynamic..\
	NOBlob=No_Of_Blobs
	act=0
	For y=1 To No_Of_Blobs
		Sliders=Sliders+1
		If level<5 Then Hole(Sliders)=MakeHoles(1)
		If level>4
			c=Rand(1,3)
			Hole(Sliders)=MakeHoles(act)
			act=act+c
		EndIf
		slide(Sliders)=Rand(-2,2)*32	; Randomly position top sliders, to make it less instant when it starts.
	Next
	If level>4 Then No_Of_Blobs=act
	
	y=1:x=1
	For n=1 To No_Of_Blobs
		found=0
		Repeat
			bit$=Mid$(Right$(Bin$(hole(y)),16),x,1)
			If bit$="1"
				found=1
				If Level=1 Then grid(x,y)=(n*10):gets(n)=grid(x,y)	; For Level 1, we just have plain numbers, top to bottom, 1-5.
				If Level=2 Then grid(x,y)=(n*2):gets(n)=grid(x,y)	; For Level 1, we just have plain numbers, top to bottom, 1-5.
				If Level=3 Then grid(x,y)=Rand(1,10)*10:gets(n)=grid(x,y)	; For Level 1, we just have plain numbers, top to bottom, 1-5.
				If Level=4 Then grid(x,y)=Rand(1,10):gets(n)=grid(x,y)	; For Level 1, we just have plain numbers, top to bottom, 1-5.
				If Level>4 Then grid(x,y)=Rand(1,100):gets(n)=grid(x,y)	; For Level 1, we just have plain numbers, top to bottom, 1-5.
			EndIf
			x=x+1
			If x=17 Then x=1:y=y+1
		Until found=1
	Next
	
	
	For y=1 To MoreSliders
		Sliders=Sliders+1
		If level<4 Then Hole(Sliders)=MakeHoles(Rand(2,5))
		If level>3 And level<8 Then Hole(Sliders)=MakeHoles(Rand(2,4))
		If level>7 Then Hole(Sliders)=MakeHoles(Rand(1,3))
		slide(Sliders)=0
	Next
	
	If level>2
		For n=1 To No_Of_Blobs
			t=Rand(1,No_Of_Blobs)
			r=gets(t)
			gets(t)=gets(n)
			gets(n)=r
		Next
	EndIf
	
	Aim_Holes=NoBlob
	For y=1 To Aim_Holes
		Sliders=Sliders+1
		If level<5 Then Hole(Sliders)=MakeHoles(1)
		If level>4 Then hole(Sliders)=MakeHoles(Rand(2,4))
		slide(Sliders)=0
	Next

	y=Sliders:x=1	; Start at the bottom
	For n=1 To No_Of_Blobs
		found=0
		Repeat
			bit$=Mid$(Right$(Bin$(hole(y)),16),x,1)
			If bit$="1"
				found=1
				grid2(x,y)=gets(n)
			EndIf
			x=x+1
			If x=17 Then x=1:y=y-1	; Work your way up..
		Until found=1
	Next
	
End Function



.GameLoop
SetFont GameFont
tmp=MouseXSpeed()
endtime=MilliSecs()+120000
Level=1
If Quickstart=1 Then Level=7:endtime=MilliSecs()+160000
endtime=MilliSecs()+5000
Gripped=0
MakeLevel(Level)
Repeat
Cls

	;GameLoop
	
	msx=MouseXSpeed()
	HasAll=1
	If settled=0 Then HasAll=0
	
	Color 80,0,0
	Rect 0,0,32,600,1
	Rect 17*32,0,800-(17*32),600,1

	For y=Sliders To 1 Step -1 ; I've turned the main loop around, so that blobs drop a little slower.
	
		txt$=Right$(Bin$(hole(y)),16)
		drawY=(y*32)	; This'll be handy once we add our loop.
		DrawImage slider_i,(0*32)+slide(y),drawY,0
		DrawImage slider_i,(17*32)+slide(y),drawY,1
		For x=1 To 16	; Draw blocks along slider.
			If Mid$(txt,x,1)=0 Then DrawImage slider,(x*32)+slide(y),drawY
			If grid2(x,y)>0 
				DrawImage blobs_dark,(x*32)+slide(y),drawY,grid2(x,y)-1
				If grid(x,y)<>grid2(x,y) Then HasAll=0	; Flags HasAll to false if there's a discrepency
			EndIf
			If grid(x,y)>0 
				; Draw a blob where they exist.
				DrawImage blobs,(x*32)+slide(y),drawY,grid(x,y)-1

				If y<sliders; And settled=1		; Only drop blobs if they're not on the bottom, and the grid's not moving..
				
					XHere=(((x*32)+slide(y)+16)/32)	;Where our block is, in relation to the grid..
					XBelow=(((XHere*32)-slide(y+1)+16)/32)
					
					
					If XHere>0 And XHere<17 And XBelow>0 And XBelow<17
						If Mid$(Right$(Bin$(hole(y+1)),16),XBelow,1)="1" And grid(XBelow,y+1)=0 Then grid(XBelow,y+1)=grid(x,y):grid(x,y)=0
					EndIf

				EndIf
			EndIf
		Next
		
			; Check if sliding.
		If MouseY()>drawY And MouseY()<drawY+32 And MouseDown(1) And (gripped=y Or gripped=0)
			gripped=y
			slide(y)=slide(y)+msx
			If slide(y)<-512 Then slide(y)=-512
			If slide(y)>512 Then slide(y)=512
			settled=0
		EndIf
		If MouseDown(1)=0 
			gripped=0
			settled=1
			For ey=1 To sliders
				If ((slide(ey)+1616) Mod 32)<>16
					If ((slide(ey)+1616) Mod 32)<16 Then slide(ey)=slide(ey)+1:settled=0
					If ((slide(ey)+1616) Mod 32)>16 Then slide(ey)=slide(ey)-1:settled=0
				EndIf
			Next
		EndIf
	Next

If HasAll=1
	Color 255,255,255
	Text 400-1,300-1,"Level Complete",1,1
	Color 0,0,0
	Text 401,301,"Level Complete",1,1
	Color 100,180,180
	Text 400,300,"Level Complete",1,1
	Flip
	
	level=level+1:MakeLevel(Level):HasAll=0:endtime=endtime+61500
	Delay 1500
EndIf


Color 0,0,0
Text 701,41,MillstoTime$(endtime-MilliSecs(),0,1,1),1,1

Color 180,0,0
Text 700,40,MillstoTime$(endtime-MilliSecs(),0,1,1),1,1

If endtime-MilliSecs()<1 
	Color 255,255,255
	Text 400-1,300-1,"GAME OVER",1,1
	Color 0,0,0
	Text 401,301,"GAME OVER",1,1
	Color 100,180,180
	Text 400,300,"GAME OVER",1,1
	Flip
	Delay 1500
	endofgame=1
EndIf

mh1=MouseHit(1)
Color 0,80,0
If MouseX()>640 And MouseY()>568 
Color 0,255,0
If mh1 Then MakeLevel(Level)
EndIf
Text 720,580,"REDO",1,1


Flip



If KeyDown(1) Then endofgame=99
Until endofgame<>0



Return


Function MillsToTime$(mills,hrson,minson,secson)
	sec=((mills/1000) Mod 60)
	mins=(((mills/1000)/60) Mod 60)
	hrs=(((mills/1000)/60)/60)
	time$=""
	If hrson Then time$=time$+Right$("00"+hrs,2)
	If hrson And minson Then time$=time$+":"
	If minson Then time$=time$+Right$("00"+mins,2)
	If secson And minson Then time$=time$+":"
	If secson Then time$=time$+Right$("00"+sec,2)
	If mills<=0 Then time$="00:00"
	Return time$
End Function

Function MakeHoles(NumberOfHoles)
	If NumberOfHoles<1 Or NumberOfHoles>8 Then NumberOfHoles=1
	Select NumberofHoles
		Case 1  value=%0000000100000000
		Case 2  value=%0001000000001000
		Case 3  value=%0001000100001000
		Case 4  value=%0010001000100010
		Case 5  value=%0100100100100100
		Case 6  value=%1001001001001001
		Case 7  value=%0101010101010100
		Case 8  value=%1010101010101010	
	End Select
	Return value
End Function

